/*
 * Another test compiling send and receive.  These are a few I want NOT to
 * work that i'm worried about.
 */

#include <array>
#include <string>

#include "cleansocks.h"
#include "cleanbuf.h"
#include "cleanip.h"
using namespace cleansocks;

struct foo {
	int a;
	short s1,s2;
	char b[20];
};

int main() {
	TCPsocket t1, t2;
	UDPsocket u1, u2;
	buffered_socket bs1(t1), bs2(t2);

	IPendpoint ipe;

	char buf1[40];
	int arr1[30];
	foo f1;
	std::string alvin("This is devlin");
	std::array<char, 20> ca20;
	std::array<unsigned char, 15> uca15;
	std::array<int, 30> ia30;

#ifdef FAIL1
	// using std::array of integers.
	send(t1, ia30, 30*sizeof(int));
#endif
#ifdef FAIL2
	// using std::array of integers.
	recv(t1, ia30, 30*sizeof(int));
#endif
#ifdef FAIL3
	// receive a string.  only for sending
	recv(t1, "Freddie");
#endif
#ifdef FAIL4
	// recvln from a plain TCP socket.
	recvln(t2, ca20);
#endif
#ifdef FAIL5
	// recvln from a plain TCP socket.
	recvln(t2, ca20, 10);
#endif
#ifdef FAIL6
	// recvln from a plain TCP socket.
	recvln(t2, ca20, 10, '\n');
#endif
#ifdef FAIL7
	// Size ane terminator backwards.
	recvln(bs2, ca20, 'y', 10);
#endif
#ifdef FAIL8
	// Terminator wrong type.  (Not detectable with simple void * recvs)
	recvln(bs2, ca20, 10, CSMSG_WAITALL);
#endif
#ifdef FAIL9
	// Size and terminator backwards.
	recvln(bs2, ca20, 'x', 10, CSMSG_WAITALL);
#endif
#ifdef FAIL10
	// Should fail from terminator type.
	recvln(bs1, ia30, 10, 22);
#endif
#ifdef FAIL11
	// Sendto without a destination
	sendto(u1, buf1, sizeof buf1);
#endif
#ifdef FAIL12
	// Array of integers.
	recvfrom(u2, ia30, CSMSG_WAITALL, ipe);
#endif
#ifdef FAIL13
	// TCP socket 
	sendto(t2, ca20, CSMSG_DONTROUTE, ipe);
#endif
#ifdef FAIL14
	// TCP socket 
	recvfrom(t2, uca15, 10, ipe);
#endif
#ifdef FAIL15
	// recvln plain udp socket.
	recvln(u2, ca20, 10, '\n');
#endif
}
